<script setup lang="ts">
import type { BaseIcon } from '@/types/base';

import {
  PlanAlt2,
  CogCode,
  AutomatedCodeAlt,
  SecureAlt2,
  ProtectAlt2,
  PackageAlt2,
  ContinuousDeliveryAlt,
  MonitorAlt2,
} from 'slippers-ui/icons';

// Temporary solution until we solve icons
const icons = {
  PlanAlt2,
  CogCode,
  AutomatedCodeAlt,
  SecureAlt2,
  ProtectAlt2,
  PackageAlt2,
  ContinuousDeliveryAlt,
  MonitorAlt2,
};

interface Column {
  name: string;
  icon: BaseIcon;
  config: {
    href: string;
  };
  features: {
    name: string;
    config: {
      href: string;
    };
  }[];
  replacement?: {
    text: string;
    product: string;
  };
}

interface TableProps {
  columns: Column[];
}

defineProps<TableProps>();
</script>

<template>
  <section class="table-section">
    <SlpContainer>
      <table id="table">
        <thead>
          <tr>
            <th v-for="column in columns" :key="column.name" scope="col" class="table-header-cell">
              <SlpIcon :icon="icons[column.icon.config.name]" size="lg" :alt="column.icon.altText" />
              <a
                :href="column.config.href"
                class="table-header-cell__link"
                :data-ga-name="column.name.toLowerCase()"
                data-ga-location="body"
              >
                {{ column.name }}
              </a>
            </th>
          </tr>
        </thead>
        <tbody>
          <tr>
            <td v-for="column in columns" :key="column.name" class="table-body-cell">
              <a
                v-for="feature in column.features"
                :key="feature.name"
                :href="feature.config.href"
                class="table-body-cell__link"
                :data-ga-name="feature.name.toLowerCase()"
                data-ga-location="body"
              >
                {{ feature.name }}
              </a>
            </td>
          </tr>
          <tr>
            <td v-for="column in columns" :key="column.name" class="table-body-cell-footer">
              <div class="table-body-cell-footer__text">{{ column?.replacement?.text }}</div>
              <div class="table-body-cell-footer__competitor">{{ column?.replacement?.product }}</div>
            </td>
          </tr>
        </tbody>
      </table>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
td,
th {
  vertical-align: top;
}

.table-section {
  background-color: $color-surface-700;
  color: $color-text-50;

  .slp-btn-tertiary {
    color: $color-text-50;
  }

  .slp-container {
    overflow: auto;
  }
}

#table {
  border: 1px solid $color-surface-600;
  border-radius: 8px;
  border-collapse: collapse;
  width: 100%;
}

.table-header-cell {
  color: $color-text-50;
  padding-top: 24px;
  padding-bottom: 24px;
  border-bottom: 1px solid $color-surface-600;

  &__link {
    display: block;
    color: $color-text-50;
    margin-top: 8px;
  }
}

.table-body-cell {
  border-right: 1px solid $color-surface-600;
  padding-right: 16px;
  padding-left: 16px;

  &__link {
    font-size: 14px;
    color: #a989f5;
    font-weight: 600;
    line-height: 16px;
    margin-bottom: 16px;
    display: block;
    &:hover {
      text-decoration: underline;
    }

    &:first-child {
      padding-top: 16px;
    }
  }
}

.table-header-cell,
.table-body-cell {
  word-wrap: break-word;
  overflow-wrap: break-word;
}

.table-body-cell-footer {
  border-right: 1px solid $color-surface-600;
  border-top: 1px solid $color-surface-600;
  padding: 24px;
  text-align: center;

  &__text {
    font-size: 11px;
    line-height: 15px;
    text-align: center;
    color: $color-surface-400;
  }

  &__competitor {
    font-size: 14px;
    line-height: 22px;
    font-weight: 600;
    color: #a2a1a6;
  }
}
</style>
